2023-06-06 06:22:09

by Benjamin Gray

[permalink] [raw]
Subject: [PATCH v2] initramfs: Encode dependency on KBUILD_BUILD_TIMESTAMP

gen_initramfs.sh has an internal dependency on KBUILD_BUILD_TIMESTAMP
for generating file mtimes that is not exposed to make, so changing
KBUILD_BUILD_TIMESTAMP will not trigger a rebuild of the archive.

Declare the mtime date as a new parameter to gen_initramfs.sh to encode
KBUILD_BUILD_TIMESTAMP in the shell command, thereby making make aware
of the dependency.

It will rebuild if KBUILD_BUILD_TIMESTAMP changes or is newly set/unset.
It will _not_ rebuild if KBUILD_BUILD_TIMESTAMP is unset before and
after. This should be fine for anyone who doesn't care about setting
specific build times in the first place.

Reviewed-by: Andrew Donnellan <[email protected]>
Tested-by: Andrew Donnellan <[email protected]>
Signed-off-by: Benjamin Gray <[email protected]>

---

v2: Remove redundant comment, quote argument to shell script
---
usr/Makefile | 1 +
usr/gen_initramfs.sh | 16 +++++++++-------
2 files changed, 10 insertions(+), 7 deletions(-)

diff --git a/usr/Makefile b/usr/Makefile
index 59d9e8b07a01..f8e1ad19e05c 100644
--- a/usr/Makefile
+++ b/usr/Makefile
@@ -64,6 +64,7 @@ quiet_cmd_initfs = GEN $@
$(CONFIG_SHELL) $< -o $@ -l $(obj)/.initramfs_data.cpio.d \
$(if $(CONFIG_INITRAMFS_ROOT_UID), -u $(CONFIG_INITRAMFS_ROOT_UID)) \
$(if $(CONFIG_INITRAMFS_ROOT_GID), -g $(CONFIG_INITRAMFS_ROOT_GID)) \
+ $(if $(KBUILD_BUILD_TIMESTAMP), -d "$(KBUILD_BUILD_TIMESTAMP)") \
$(ramfs-input)

# We rebuild initramfs_data.cpio if:
diff --git a/usr/gen_initramfs.sh b/usr/gen_initramfs.sh
index 63476bb70b41..14b5782f961a 100755
--- a/usr/gen_initramfs.sh
+++ b/usr/gen_initramfs.sh
@@ -23,6 +23,7 @@ $0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
-g <gid> Group ID to map to group ID 0 (root).
<gid> is only meaningful if <cpio_source> is a
directory. "squash" forces all files to gid 0.
+ -d <date> Use date for all file mtime values
<cpio_source> File list or directory for cpio archive.
If <cpio_source> is a .cpio file it will be used
as direct input to initramfs.
@@ -190,6 +191,7 @@ prog=$0
root_uid=0
root_gid=0
dep_list=
+timestamp=
cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)
output="/dev/stdout"

@@ -218,6 +220,13 @@ while [ $# -gt 0 ]; do
[ "$root_gid" = "-1" ] && root_gid=$(id -g || echo 0)
shift
;;
+ "-d") # date for file mtimes
+ timestamp="$(date -d"$1" +%s || :)"
+ if test -n "$timestamp"; then
+ timestamp="-t $timestamp"
+ fi
+ shift
+ ;;
"-h")
usage
exit 0
@@ -237,11 +246,4 @@ done

# If output_file is set we will generate cpio archive
# we are careful to delete tmp files
-timestamp=
-if test -n "$KBUILD_BUILD_TIMESTAMP"; then
- timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
- if test -n "$timestamp"; then
- timestamp="-t $timestamp"
- fi
-fi
usr/gen_init_cpio $timestamp $cpio_list > $output
--
2.40.1



2023-06-06 07:52:13

by Nicolas Schier

[permalink] [raw]
Subject: Re: [PATCH v2] initramfs: Encode dependency on KBUILD_BUILD_TIMESTAMP

On Tue, Jun 06, 2023 at 04:17:41PM +1000, Benjamin Gray wrote:
> gen_initramfs.sh has an internal dependency on KBUILD_BUILD_TIMESTAMP
> for generating file mtimes that is not exposed to make, so changing
> KBUILD_BUILD_TIMESTAMP will not trigger a rebuild of the archive.
>
> Declare the mtime date as a new parameter to gen_initramfs.sh to encode
> KBUILD_BUILD_TIMESTAMP in the shell command, thereby making make aware
> of the dependency.
>
> It will rebuild if KBUILD_BUILD_TIMESTAMP changes or is newly set/unset.
> It will _not_ rebuild if KBUILD_BUILD_TIMESTAMP is unset before and
> after. This should be fine for anyone who doesn't care about setting
> specific build times in the first place.
>
> Reviewed-by: Andrew Donnellan <[email protected]>
> Tested-by: Andrew Donnellan <[email protected]>
> Signed-off-by: Benjamin Gray <[email protected]>
>
> ---
>
> v2: Remove redundant comment, quote argument to shell script
> ---

Reviewed-by: Nicolas Schier <[email protected]>


> usr/Makefile | 1 +
> usr/gen_initramfs.sh | 16 +++++++++-------
> 2 files changed, 10 insertions(+), 7 deletions(-)
>
> diff --git a/usr/Makefile b/usr/Makefile
> index 59d9e8b07a01..f8e1ad19e05c 100644
> --- a/usr/Makefile
> +++ b/usr/Makefile
> @@ -64,6 +64,7 @@ quiet_cmd_initfs = GEN $@
> $(CONFIG_SHELL) $< -o $@ -l $(obj)/.initramfs_data.cpio.d \
> $(if $(CONFIG_INITRAMFS_ROOT_UID), -u $(CONFIG_INITRAMFS_ROOT_UID)) \
> $(if $(CONFIG_INITRAMFS_ROOT_GID), -g $(CONFIG_INITRAMFS_ROOT_GID)) \
> + $(if $(KBUILD_BUILD_TIMESTAMP), -d "$(KBUILD_BUILD_TIMESTAMP)") \
> $(ramfs-input)
>
> # We rebuild initramfs_data.cpio if:
> diff --git a/usr/gen_initramfs.sh b/usr/gen_initramfs.sh
> index 63476bb70b41..14b5782f961a 100755
> --- a/usr/gen_initramfs.sh
> +++ b/usr/gen_initramfs.sh
> @@ -23,6 +23,7 @@ $0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
> -g <gid> Group ID to map to group ID 0 (root).
> <gid> is only meaningful if <cpio_source> is a
> directory. "squash" forces all files to gid 0.
> + -d <date> Use date for all file mtime values
> <cpio_source> File list or directory for cpio archive.
> If <cpio_source> is a .cpio file it will be used
> as direct input to initramfs.
> @@ -190,6 +191,7 @@ prog=$0
> root_uid=0
> root_gid=0
> dep_list=
> +timestamp=
> cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)
> output="/dev/stdout"
>
> @@ -218,6 +220,13 @@ while [ $# -gt 0 ]; do
> [ "$root_gid" = "-1" ] && root_gid=$(id -g || echo 0)
> shift
> ;;
> + "-d") # date for file mtimes
> + timestamp="$(date -d"$1" +%s || :)"
> + if test -n "$timestamp"; then
> + timestamp="-t $timestamp"
> + fi
> + shift
> + ;;
> "-h")
> usage
> exit 0
> @@ -237,11 +246,4 @@ done
>
> # If output_file is set we will generate cpio archive
> # we are careful to delete tmp files
> -timestamp=
> -if test -n "$KBUILD_BUILD_TIMESTAMP"; then
> - timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
> - if test -n "$timestamp"; then
> - timestamp="-t $timestamp"
> - fi
> -fi
> usr/gen_init_cpio $timestamp $cpio_list > $output
> --
> 2.40.1
>

2023-06-07 05:49:43

by Masahiro Yamada

[permalink] [raw]
Subject: Re: [PATCH v2] initramfs: Encode dependency on KBUILD_BUILD_TIMESTAMP

On Tue, Jun 6, 2023 at 3:18 PM Benjamin Gray <[email protected]> wrote:
>
> gen_initramfs.sh has an internal dependency on KBUILD_BUILD_TIMESTAMP
> for generating file mtimes that is not exposed to make, so changing
> KBUILD_BUILD_TIMESTAMP will not trigger a rebuild of the archive.
>
> Declare the mtime date as a new parameter to gen_initramfs.sh to encode
> KBUILD_BUILD_TIMESTAMP in the shell command, thereby making make aware
> of the dependency.
>
> It will rebuild if KBUILD_BUILD_TIMESTAMP changes or is newly set/unset.
> It will _not_ rebuild if KBUILD_BUILD_TIMESTAMP is unset before and
> after. This should be fine for anyone who doesn't care about setting
> specific build times in the first place.
>
> Reviewed-by: Andrew Donnellan <[email protected]>
> Tested-by: Andrew Donnellan <[email protected]>
> Signed-off-by: Benjamin Gray <[email protected]>
>
> ---


Applied to linux-kbuild. Thanks.




> v2: Remove redundant comment, quote argument to shell script
> ---
> usr/Makefile | 1 +
> usr/gen_initramfs.sh | 16 +++++++++-------
> 2 files changed, 10 insertions(+), 7 deletions(-)
>
> diff --git a/usr/Makefile b/usr/Makefile
> index 59d9e8b07a01..f8e1ad19e05c 100644
> --- a/usr/Makefile
> +++ b/usr/Makefile
> @@ -64,6 +64,7 @@ quiet_cmd_initfs = GEN $@
> $(CONFIG_SHELL) $< -o $@ -l $(obj)/.initramfs_data.cpio.d \
> $(if $(CONFIG_INITRAMFS_ROOT_UID), -u $(CONFIG_INITRAMFS_ROOT_UID)) \
> $(if $(CONFIG_INITRAMFS_ROOT_GID), -g $(CONFIG_INITRAMFS_ROOT_GID)) \
> + $(if $(KBUILD_BUILD_TIMESTAMP), -d "$(KBUILD_BUILD_TIMESTAMP)") \
> $(ramfs-input)
>
> # We rebuild initramfs_data.cpio if:
> diff --git a/usr/gen_initramfs.sh b/usr/gen_initramfs.sh
> index 63476bb70b41..14b5782f961a 100755
> --- a/usr/gen_initramfs.sh
> +++ b/usr/gen_initramfs.sh
> @@ -23,6 +23,7 @@ $0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
> -g <gid> Group ID to map to group ID 0 (root).
> <gid> is only meaningful if <cpio_source> is a
> directory. "squash" forces all files to gid 0.
> + -d <date> Use date for all file mtime values
> <cpio_source> File list or directory for cpio archive.
> If <cpio_source> is a .cpio file it will be used
> as direct input to initramfs.
> @@ -190,6 +191,7 @@ prog=$0
> root_uid=0
> root_gid=0
> dep_list=
> +timestamp=
> cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)
> output="/dev/stdout"
>
> @@ -218,6 +220,13 @@ while [ $# -gt 0 ]; do
> [ "$root_gid" = "-1" ] && root_gid=$(id -g || echo 0)
> shift
> ;;
> + "-d") # date for file mtimes
> + timestamp="$(date -d"$1" +%s || :)"
> + if test -n "$timestamp"; then
> + timestamp="-t $timestamp"
> + fi
> + shift
> + ;;
> "-h")
> usage
> exit 0
> @@ -237,11 +246,4 @@ done
>
> # If output_file is set we will generate cpio archive
> # we are careful to delete tmp files
> -timestamp=
> -if test -n "$KBUILD_BUILD_TIMESTAMP"; then
> - timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
> - if test -n "$timestamp"; then
> - timestamp="-t $timestamp"
> - fi
> -fi
> usr/gen_init_cpio $timestamp $cpio_list > $output
> --
> 2.40.1
>


--
Best Regards
Masahiro Yamada